#!/bin/sh
# 
# Pass through lines to stdout, interpret "@include FILE" directives.
# Input comes from the files listed on the command line, or stdin.
#
set -e

# Switch off word splitting which interferes with `read' builtin.
IFS=

# Drop first word.
drop() {
    echo "$@" | cut -d ' ' -f 2-
}

cat_with_include() {
    while read -r line
    do
	case $line in
	    "@include "*)
		cat_with_include < `drop $line`
		echo
		;;
	    *)
		echo "$line"
		;;
	esac
    done
}

if test $# = 0
then
    cat_with_include
else
    for x in "$@"
    do
	cat_with_include < $x
    done
fi
